# Makefile.rl --
#
# Part of: tclmore
# Contents: makefile variables
# Date: Fri Oct 25, 2002
#
# Abstract
#
#	This file declares the rules specific to the project.
#
# Copyright (C) 2002, 2003, 2004 Marco Maggi.
#
# The author  hereby grant permission to use,  copy, modify, distribute,
# and  license this  software  and its  documentation  for any  purpose,
# provided that  existing copyright notices  are retained in  all copies
# and that  this notice  is included verbatim  in any  distributions. No
# written agreement, license, or royalty  fee is required for any of the
# authorized uses.  Modifications to this software may be copyrighted by
# their authors and need not  follow the licensing terms described here,
# provided that the new terms are clearly indicated on the first page of
# each file where they apply.
# 
# IN NO  EVENT SHALL THE AUTHOR  OR DISTRIBUTORS BE LIABLE  TO ANY PARTY
# FOR  DIRECT, INDIRECT, SPECIAL,  INCIDENTAL, OR  CONSEQUENTIAL DAMAGES
# ARISING OUT  OF THE  USE OF THIS  SOFTWARE, ITS DOCUMENTATION,  OR ANY
# DERIVATIVES  THEREOF, EVEN  IF THE  AUTHOR  HAVE BEEN  ADVISED OF  THE
# POSSIBILITY OF SUCH DAMAGE.
# 
# THE  AUTHOR  AND DISTRIBUTORS  SPECIFICALLY  DISCLAIM ANY  WARRANTIES,
# INCLUDING,   BUT   NOT  LIMITED   TO,   THE   IMPLIED  WARRANTIES   OF
# MERCHANTABILITY,    FITNESS   FOR    A    PARTICULAR   PURPOSE,    AND
# NON-INFRINGEMENT.  THIS  SOFTWARE IS PROVIDED  ON AN "AS  IS" BASIS,
# AND  THE  AUTHOR  AND  DISTRIBUTORS  HAVE  NO  OBLIGATION  TO  PROVIDE
# MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
#

#PAGE
## ------------------------------------------------------------
## Source files.
## ------------------------------------------------------------

$(PACKAGE_NAME)_SOURCES	= init.c commands.c			\
			  error.c commandinterface.c		\
			  identifier.c				\
			  object.c extractor.c			\
			  variable.c buffer.c			\
			  buffervariable.c bufferchannel.c	\
			  varchan.c teechan.c pipechan.c	\
			  miscellaneous.c channel.c dstring.c	\
			  streamtransform.c delayedscript.c


$(PACKAGE_NAME)_HEADERS	= $(top_srcdir)/generic/tclmore.h \
			  $(top_srcdir)/generic/tclmoreDecls.h

$($(PACKAGE_NAME)_SOURCES:.c=.$(OBJEXT)): tclmoreDecls.h tclmoreInt.h

commands.o: declaration.c
commandstest.o: testcmd.c

%.o: tclmoreDecls.h tclmoreInt.h

#PAGE
## ------------------------------------------------------------
## Development scripts.
## ------------------------------------------------------------

devscripts_INSTLST	= $(addprefix $(top_srcdir)/xml/, \
				tclcommand.tcl2data		\
				tclcommand.data2declaration)

devscripts_INSTDIR	= $(pkglibexecdir)


.PHONY: devscripts-install

devscripts-install:
AM_INSTALL_BIN(devscripts)

dev-install: devscripts-install

#PAGE
## ------------------------------------------------------------
## Autoconf files.
## ------------------------------------------------------------

autoconf_INSTLST	= $(builddir)/aclocal/tclmore.m4
autoconf_INSTDIR	= $(datadir)/aclocal

.PHONY: autoconf-install

autoconf-install:
AM_INSTALL_DATA(autoconf)

dev-install: autoconf-install

### end of file
# Local Variables:
# mode: makefile
# page-delimiter: "^#PAGE"
# End:
