/* tclmoreInt.h --
   
   Part of: tclmore
   Contents: internal header file
   Date: Fri Apr 26, 2002
   
   Abstract:
   
	This file is included in all the tclmore source files.   
   
   Copyright (c) 2002, 2003, 2004 Marco Maggi
   
   The author  hereby grant permission to use,  copy, modify, distribute,
   and  license this  software  and its  documentation  for any  purpose,
   provided that  existing copyright notices  are retained in  all copies
   and that  this notice  is included verbatim  in any  distributions. No
   written agreement, license, or royalty  fee is required for any of the
   authorized uses.  Modifications to this software may be copyrighted by
   their authors and need not  follow the licensing terms described here,
   provided that the new terms are clearly indicated on the first page of
   each file where they apply.
   
   IN NO  EVENT SHALL THE AUTHOR  OR DISTRIBUTORS BE LIABLE  TO ANY PARTY
   FOR  DIRECT, INDIRECT, SPECIAL,  INCIDENTAL, OR  CONSEQUENTIAL DAMAGES
   ARISING OUT  OF THE  USE OF THIS  SOFTWARE, ITS DOCUMENTATION,  OR ANY
   DERIVATIVES  THEREOF, EVEN  IF THE  AUTHOR  HAVE BEEN  ADVISED OF  THE
   POSSIBILITY OF SUCH DAMAGE.
   
   THE  AUTHOR  AND DISTRIBUTORS  SPECIFICALLY  DISCLAIM ANY  WARRANTIES,
   INCLUDING,   BUT   NOT  LIMITED   TO,   THE   IMPLIED  WARRANTIES   OF
   MERCHANTABILITY,    FITNESS   FOR    A    PARTICULAR   PURPOSE,    AND
   NON-INFRINGEMENT.  THIS  SOFTWARE IS PROVIDED  ON AN "AS  IS" BASIS,
   AND  THE  AUTHOR  AND  DISTRIBUTORS  HAVE  NO  OBLIGATION  TO  PROVIDE
   MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
   
*/

#ifndef __TCLMOREINT_H
#define __TCLMOREINT_H 1


/** ------------------------------------------------------------
 ** Header files.
 ** ----------------------------------------------------------*/

#include <tcl.h>

#ifdef __cplusplus
extern "C" {
#endif


/** ------------------------------------------------------------
 ** Preprocessor symbols and macros.
 ** ----------------------------------------------------------*/

/*
   Windows  needs to  know  which  symbols to  export.   Unix does  not.
   BUILD_tclmore should be undefined for Unix.
*/

#ifdef BUILD_tclmore
#  undef TCL_STORAGE_CLASS
#  define TCL_STORAGE_CLASS DLLEXPORT
#endif 

#define More_AssocKey		  "tclmore"
#define More_GetAssocData(interp) Tcl_GetAssocData((interp), "tclmore", NULL)


/** ------------------------------------------------------------
 ** Include files.
 ** ----------------------------------------------------------*/

#include "tclmoreDecls.h"


/** ------------------------------------------------------------
 ** Type declarations.
 ** ----------------------------------------------------------*/

typedef struct More_AssocData {
  int			channelCountersInitialised;
  Tcl_HashTable		channelCounters;
} More_AssocData;


/** ------------------------------------------------------------
 ** Prototypes.
 ** ----------------------------------------------------------*/

EXTERN int	Tclmore_Init		_ANSI_ARGS_((Tcl_Interp *interp));
EXTERN int	Tclmore_SafeInit	_ANSI_ARGS_((Tcl_Interp *interp));

EXTERN More_CommandTreeNode More_Commands[];


/** ------------------------------------------------------------
 ** Global variables.
 ** ----------------------------------------------------------*/

EXTERN CONST More_StubTable			moreStub;
EXTERN CONST More_StubTableError		moreStubError;
EXTERN CONST More_StubTableIdTable		moreStubIdTable;
EXTERN CONST More_StubTableVariable		moreStubVariable;
EXTERN CONST More_StubTableChannelInterface	moreStubChannelInterface;
EXTERN CONST More_StubTableChannelDriver	moreStubChannelDriver;
EXTERN CONST More_StubTableObjectExtractor	moreStubObjectExtractor;
EXTERN CONST More_StubTableArgumentExtractor	moreStubArgumentExtractor;
EXTERN CONST More_StubTableBuffer		moreStubBuffer;
EXTERN CONST More_StubTableDString		moreStubDString;
EXTERN CONST More_StubTableStream		moreStubStream;
EXTERN CONST More_StubTableMisc			moreStubMisc;
EXTERN CONST More_StubTableDelayedScript	moreStubDelayedScript;

#ifdef __cplusplus
} /* end C++ block */
#endif

#endif /* __TCLMOREINT_H */

/* end of file */
